#define PROCESSING_TEXTURE_SHADER

uniform sampler2D texture;
varying vec4 vertTexCoord;
varying vec4 colors;

vec4 contrast(vec4 colors, float contrast)
{
  colors.rgb /= colors.a;
  colors.rgb = ((colors.rgb - 0.5) * max(contrast + 1.0, 0.0)) + 0.5;
  colors.rgb *= colors.a;
  return colors;
}

vec4 brightness(vec4 colors, float brightness)
{
  colors.rgb /= colors.a;
  colors.rgb *= brightness;
  colors.rgb *= colors.a;
  return colors;
}

void main(void)
{
	vec4 colors = texture2D(texture, vertTexCoord.st).rgba;
    	float i = mix(colors.r, colors.g, colors.b);

    
	float ratioBrightness = 1. / pow(float(2.1 - i),12.);
	float ratioContrast = 0.5;
    
	gl_FragColor = brightness(contrast(colors,ratioContrast), ratioBrightness);
} 