void OSCInit (){
  sendOSCMessage("/main/zoomValue", 0.2);
  sendOSCMessage("/main/fadeValue", 0.1);
  sendOSCMessage("/main/rotateValue", 0.5);
  sendOSCMessage("/main/slideValue", 0.5);

  sendOSCValues("/main/persist", 6, 1, 0.0);
  sendOSCValues("/main/transitionType", 2, 4, 0.0);
  sendOSCMessage("/main/transitionType/4/1", 1.0);
  sendOSCValues("/main/mode", 4, 1, 0.0);
  sendOSCMessage("/main/mode/1/1", 1.0);

  sendOSCValues("/patterns/togglePattern", 8, 6, 0.0);

  sendOSCValues("/persist/displayToggle", 1, 6, 0.0);
  sendOSCValues("/persist/persistFadeType", 4, 2, 0.0);
  sendOSCMessage("/persist/persistFadeType/2/1", 1.0);

  sendOSCMessage("/persist/captureZoneTopLeft", 0.0);
  sendOSCMessage("/persist/captureZoneTop", 0.0);
  sendOSCMessage("/persist/captureZoneTopRight", 0.0);
  sendOSCMessage("/persist/captureZoneLeft", 0.0);
  sendOSCMessage("/persist/captureZoneAll", 1.0);
  sendOSCMessage("/persist/captureZoneRight", 0.0);
  sendOSCMessage("/persist/captureZoneBottomLeft", 0.0);
  sendOSCMessage("/persist/captureZoneBottom", 0.0);
  sendOSCMessage("/persist/captureZoneBottomRight", 0.0);

  sendOSCMessage("/main/fadeActive", 1.0);
  sendOSCMessage("/main/zoomActive", 0.0);
  sendOSCMessage("/main/rotateActive", 0.0);
  sendOSCMessage("/main/slideActive", 0.0);


  sendOSCMessage("/greenScreen/hue", HUE);
  sendOSCMessage("/greenScreen/hue_range", HUE_range);
  sendOSCMessage("/greenScreen/saturation", SAT);
  sendOSCMessage("/greenScreen/saturation_range", SAT_range);
  sendOSCMessage("/greenScreen/brightness", BRI);
  sendOSCMessage("/greenScreen/brightnessRange", BRI_range);
  sendOSCMessage("/greenScreen/yikes", yikes);
  sendOSCMessage("/greenScreen/active", 0);
  sendOSCMessage("/greenScreen/calibrate", 0);

}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void sendOSCMessage(String address, float value){
  OscMessage myMessage = new  OscMessage(address);
  myMessage.add(value);
  oscP5.send(myMessage);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void sendOSCValues(String base, int cols, int rows, float value){
  for(int i = 1; i <= cols; i++){
    for(int j = 1; j <= rows; j++){
//      println(base + "/" + j + "/" + i);
//      println(value);
      sendOSCMessage(base + "/" + j + "/" + i, value);
    }
  }
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void oscEvent(OscMessage theOscMessage) {
  String Pattern = theOscMessage.addrPattern();


  println("### received an osc message. with address pattern "+
          Pattern +" typetag "+ theOscMessage.typetag());
  if(theOscMessage.checkTypetag("f")) {
      float OSCvalue = theOscMessage.get(0).floatValue(); // get the second osc argument
      println(" values: "+OSCvalue);
      
      if(Pattern.substring(0, Math.min(12, Pattern.length())).equals("/main/mode/1")){
        sendOSCValues("/main/mode", 4, 1, 0.0);
        sendOSCMessage(Pattern, 1.0);
        if(Pattern.equals("/main/mode/1/1")){
          mode = MODE_FADE;
          greenScreenActive = 0;
          instructions("Mode set to fade");
          activePattern = 0;
        }else if(Pattern.equals("/main/mode/1/2")){
          greenScreenActive = 0;
          mode = MODE_LIGHTPAINTING;
          instructions("Mode set to light painting");
          activePattern = 0;
        }else if(Pattern.equals("/main/mode/1/3")){
          activePattern = 0;
          mode = MODE_LIGHTPAINTING;
          instructions("Mode set to green screen");
        }
      }
      
      if(Pattern.substring(0, Math.min(20, Pattern.length())).equals("/main/transitionType")){
        sendOSCValues("/main/transitionType", 2, 4, 0.0);
        sendOSCMessage(Pattern, 1.0);
      }
      
      if(Pattern.substring(0, Math.min(23, Pattern.length())).equals("/patterns/togglePattern")){
        sendOSCValues("/patterns/togglePattern", 8, 6, 0.0);
        sendOSCValues("/main/mode", 4, 1, 0.0); // disable modes
        sendOSCMessage(Pattern, OSCvalue);
        if(OSCvalue == 1){
          sendOSCMessage("/main/mode/1/4", 1.0);
        }else{
          sendOSCMessage("/main/mode/1/4", 0.0);
          sendOSCMessage("/main/mode/1/1", 1.0);
        }
      }
      
      if(Pattern.substring(0, Math.min(24, Pattern.length())).equals("/persist/persistFadeType")){
        sendOSCValues("/persist/persistFadeType", 4, 2, 0.0);
        sendOSCMessage(Pattern, 1.0);
      }
      
      if(Pattern.substring(0, Math.min(20, Pattern.length())).equals("/persist/captureZone")){
        sendOSCMessage("/persist/captureZoneTopLeft", 0.0);
        sendOSCMessage("/persist/captureZoneTop", 0.0);
        sendOSCMessage("/persist/captureZoneTopRight", 0.0);
        sendOSCMessage("/persist/captureZoneLeft", 0.0);
        sendOSCMessage("/persist/captureZoneAll", 0.0);
        sendOSCMessage("/persist/captureZoneRight", 0.0);
        sendOSCMessage("/persist/captureZoneBottomLeft", 0.0);
        sendOSCMessage("/persist/captureZoneBottom", 0.0);
        sendOSCMessage("/persist/captureZoneBottomRight", 0.0);

        sendOSCMessage(Pattern, 1.0);
      }

      if(Pattern.substring(0, Math.min(13, Pattern.length())).equals("/main/persist")){
        String persistnumber = Pattern.substring(Pattern.length()-1, Pattern.length());
        sendOSCMessage("/main/persist/1/" + persistnumber , OSCvalue);
        sendOSCMessage("/persist/displayToggle/" + persistnumber + "/1" , OSCvalue);
      }
      
      if(Pattern.substring(0, Math.min(22, Pattern.length())).equals("/persist/displayToggle")){
        String persistnumber = Pattern.substring(Pattern.length()-3, Pattern.length()-2);
        sendOSCMessage("/main/persist/1/" + persistnumber , OSCvalue);
        sendOSCMessage("/persist/displayToggle/" + persistnumber + "/1" , OSCvalue);
      }
      
      
      if(Pattern.equals("/main/rotateReset")){
        if(OSCvalue == 1.0){
          sendOSCMessage("/main/rotateValue", 0.5);
        }
      }
      
      if(Pattern.equals("/main/fadeReset")){
        if(OSCvalue == 1.0){
          sendOSCMessage("/main/fadeValue", 0.1);
          fadetint = STARTINGFADETINT;
        }
      }      
      if(Pattern.equals("/main/fadeValue")){
        fadetint = max(0, 255 - int(30.0 * OSCvalue));
      }
      
      if(Pattern.equals("/main/slideReset")){
        if(OSCvalue == 1.0){
          sendOSCMessage("/main/slideValue", 0.5);
          slide = 0;
        }
      }      
      if(Pattern.equals("/main/slideValue")){
        slide = int((OSCvalue - 0.5) * 50);
      }
      
      if(Pattern.equals("/main/zoomReset")){
        if(OSCvalue == 1.0){
          sendOSCMessage("/main/zoomValue", 0.2);
          scalefactor = 1;
        }
      }
      
      if(Pattern.equals("/main/zoomValue")){
        scalefactor = 1 + (OSCvalue - 0.2);
      }
      
      if(Pattern.equals("/main/saveOrNew/1/1")){
        saveImage = 1;
      }
      
      if(Pattern.equals("/main/saveOrNew/2/1")){
        saveImage = 1;
//        resetImage = 1;
        setfadetype(FADE_BLOCKOUT);
      }
      
      if(Pattern.equals("/main/saveOrNew/3/1")){
//        resetImage = 1;
          setfadetype(FADE_BLOCKOUT);
      }
      
      if(Pattern.equals("/patterns/togglePattern/6/1")){
        togglestopmotionslide();
      }
      
      if(Pattern.equals("/patterns/togglePattern/6/2")){
        key = '1';keyReleased();
        if(OSCvalue == 0.0){
          mode = MODE_FADE;
          sendOSCMessage("/main/mode/1/1", 1.0);
          activePattern = 0;
        }
      }
        
      if(Pattern.equals("/patterns/togglePattern/6/3")){
        key = '2';keyReleased();
        if(OSCvalue == 0.0){
          mode = MODE_FADE;
          sendOSCMessage("/main/mode/1/1", 1.0);
          activePattern = 0;
        }
      }
        
      if(Pattern.equals("/main/zoomActive")){
        zoomOn = int(OSCvalue);
      }
      if(Pattern.equals("/main/rotateActive")){
        rotateOn = int(OSCvalue);
      }
      if(Pattern.equals("/main/slideActive")){
        slideOn = int(OSCvalue);
      }
      if(Pattern.equals("/main/fadeActive")){
        fadeOn = int(OSCvalue);
      }
        

      
      if(Pattern.equals("/greenScreen/hue")){
        HUE = OSCvalue;
      }
      if(Pattern.equals("/greenScreen/hueRange")){
        HUE_range = OSCvalue;
      }
      if(Pattern.equals("/greenScreen/brightness")){
        BRI = OSCvalue;
      }
      if(Pattern.equals("/greenScreen/brightnessRange")){
        BRI_range = OSCvalue;
      }
      if(Pattern.equals("/greenScreen/saturation")){
        SAT = OSCvalue;
      }
      if(Pattern.equals("/greenScreen/saturationRange")){
        SAT_range = OSCvalue;
      }
      if(Pattern.equals("/greenScreen/yikes")){
        yikes = OSCvalue;
      }
      if(Pattern.equals("/greenScreen/active")){
        greenScreenActive = int(OSCvalue);
      }
      if(Pattern.equals("/greenScreen/calibrate")){
        greenScreenCalibrate = int(OSCvalue);
      }
      
      

    }          

  if(theOscMessage.checkTypetag("ff")) {
      float OSCvalue = theOscMessage.get(0).floatValue(); // get the second osc argument
      println(" values: "+OSCvalue);
      OSCvalue = theOscMessage.get(1).floatValue(); // get the second osc argument
      println(" values: "+OSCvalue);
    }
}