final int LIGHTPAINTING = 1 << 0;

final int SAVEIMAGE = 1 << 1;
final int NEWIMAGE = 1 <<  2;

final int FADEIMAGE = 1 <<  3; // MUTUALLY EXCLUSIVE TO LIGHTPAINTING, FADE OVER A SECOND

final int ZOOMOUTFAST = 1 <<  4;
final int ZOOMOUTMEDIUM = 1 <<  5;
final int ZOOMINMEDIUM = 1 <<  6;

final int NOCAMERA = 1 <<  7;
final int DISSOLVEBLOCK3D = 1 <<  8; // NOT READY YET

final int MEDIUMSHIFTLEFT = 1 <<  9;
final int MEDIUMSHIFTRIGHT = 1 <<  10;

final int ROTATELEFT = 1 <<  11;
final int ROTATERIGHT = 1 <<  12;

final int MIRRORX = 1 <<  13;
final int MIRRORQUAD = 1 <<  14;

final int RANDOM = 1 <<  15;

final int FADESLIDE = 1 <<  16;
final int FADEBLOCKOUT = 1 <<  17;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void startPattern(int i){
  patternFrame = 0;
  activePattern = i;
  println(activePattern);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void setUpPatterns(){
  
  // 10 seconds of light painting, then fade
  pattern1[0] = NEWIMAGE + LIGHTPAINTING;
//  pattern1[10 * fps] = SAVEIMAGE + FADEIMAGE + NOCAMERA + ZOOMOUTFAST;
//  pattern1[(PATTERN2SECONDS - 2) * FPS] = SAVEIMAGE + FADEIMAGE + NOCAMERA + ZOOMOUTFAST;
//  pattern1[pattern1.length - 1] = SAVEIMAGE + FADESLIDE;
//  pattern1[pattern1.length - 1] = SAVEIMAGE + FADEBLOCKOUT;
  pattern1[pattern1.length - 1] =  FADEBLOCKOUT;

  // 20 seconds of light painting, then fade
  pattern2[0] = NEWIMAGE + LIGHTPAINTING;
  pattern2[pattern2.length - 1] =  FADEBLOCKOUT;

}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int[] initializePattern(int seconds){
  int[] thispattern = {};
  for(int i = 0; i < seconds * FPS; i++){
    thispattern = append(thispattern, 0);
//    println(thispattern[0]);
  }
  
  return thispattern;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int checkPattern(){
  int patternSetting = 0;
  int countOfFrames = 999999;
//    println("checking pattern");
  
  if(activePattern > 0){
//    println("active pattern");
    if(activePattern == 1){
//    println(patternFrame);
      patternSetting = pattern1[patternFrame];
      countOfFrames = pattern1.length;
//    println(countOfFrames);
    }else if(activePattern == 2){
      patternSetting = pattern2[patternFrame];
      countOfFrames = pattern2.length;
    }
    // if it's zero do nothing
    if(patternSetting == 0){
//    println("zero setting");
      // do nothing
    }else{
//    println(patternSetting);
    
      // otherwise reset all to default
      mode = MODE_FADE;
      scalefactor = 1.0;
      slide = 0;
      fadetint = STARTINGFADETINT;
      addCamera = 1;
      
      if(int(patternSetting & SAVEIMAGE) > 0){
        savefile();
      }

      if(int(patternSetting & LIGHTPAINTING) > 0){
        mode = MODE_LIGHTPAINTING;
      }

      if(int(patternSetting & NEWIMAGE) > 0){
        resetImage = 1;
      }

      if(int(patternSetting & FADEIMAGE) > 0){
        // this is default
      }

      if(int(patternSetting & NOCAMERA) > 0){
        addCamera = 0;
      }

      if(int(patternSetting & ZOOMOUTFAST) > 0){
        scalefactor = 1.05;
        println("zoom out fast");
      }
      
      if(int(patternSetting & FADESLIDE) > 0){
        setfadetype(FADE_SLIDE);
        println("fade slide");
      }
      if(int(patternSetting & FADEBLOCKOUT) > 0){
        setfadetype(FADE_BLOCKOUT);
        println("fade slide");
      }
      


      
      // activate chosen settings
    
    }
    
    // increase framecount, if framecount is too big then reset it
    patternFrame++;
    if(patternFrame >= countOfFrames){
//println("resetting frame count");      
      patternFrame = 0;
    }else{
//    println("NOT resetting frame count");      
  }
    
    return 1;
  }else{
    return 0;
  }
  
}